//mrx_VS1063.c
//(VS1063 + PIC32MZ2048EFH100_SPI1)p\[Xt@C
//{CuHarmonyMHC̎gpOɂĂ܂B
////@MHC̐ݒv
//  1. IDLE_LOW_EDGE_RISE 
//  2. SAMPLING_PHASE_MIDDLE
//  3. SPI{[[gF3.125MHz
//  4. SPIW[SCK,SDO,SDI̊epinATCw 

#include "mrx_VS1063.h"
#include "vs1063a-encpatches.plg"
#include "stdio.h"

#include <p32xxxx.h>

int ysNum;
char Buf[32];

int iy;



unsigned char VS1063_WriteSPI(unsigned char data)   //SPIobt@ǂݏ
{
    unsigned char value;
    
    VS1063_SPI_IF = 0;      //MtONA
    VS1063_SSPBUF = data;   // SPIobt@֏o
    while(!VS1063_SPI_IF);  //M݃tO҂
    value = VS1063_SSPBUF;  //߂l 擾   //SPIobt@ǂݍ
    return value;
}


unsigned short int mrxVS1063_ReadSci(unsigned char addr)    //WX^lǂݏo
{
    unsigned short int    val = 0;
    
    VS1063_XCS = 0;			// R}hM[h@ON
    VS1063_WriteSPI(0x03);			// ǂݍݓ
    VS1063_WriteSPI(addr);		// WX^AhXw
    val = VS1063_WriteSPI(0x00);
    val <<= 8;
    val |= VS1063_WriteSPI(0x00);
    
    VS1063_XCS = 1;			// R}hM[h@ON
    return val;
}


void mrxVS1063_WriteSci(unsigned char addr, unsigned short int val) //WX^ւ̏݁@ǂݏo`FbNȂ
{
    VS1063_XCS = 0;			// R}hM[h@ON
    VS1063_WriteSPI(0x02);			// ݓw
    VS1063_WriteSPI(addr);		// WX^AhXo
    VS1063_WriteSPI(val >> 8);		// ʃoCgo
    VS1063_WriteSPI(val & 0x00FF);		// ʃoCgo
    VS1063_XCS = 1;			// R}hM[h@OFF
}



unsigned short int mrxVS1063_ReadWram(unsigned short int addr) //RAMi2oCgAhXjւ̃ANZXp  
                                                                 //t@CύXɍۂAVS1063aRAM(0x1e06)ɒڃANZX
{
    mrxVS1063_WriteSci(SCI_WRAMADDR, addr);
    return mrxVS1063_ReadSci(SCI_WRAM);
}



void VS1063_SendData(unsigned char data)    //VS1063ւ̑M
{
	while(!VS1063_DREQ);		//VS1063̏҂
	VS1063_WriteSPI(data);
}


void VS1063_CommandSendOn(void)     // R}hM[h@ON 
{
   VS1063_XCS = 0;			
}

void VS1053_CommandSendOff(void)    // R}hM[h@OFF 
{
   VS1063_XCS = 1;			
}

void VS1063_DataSendOn(void)         // f[^M[h@ON 
{
    VS1063_XDCS = 0;	
}

void VS1063_DataSendOff(void)        // f[^M[h@OFF 
{
    VS1063_XDCS = 1;	
}


void VS1063_ResetOn(void)   //VS1063̃Zbg|[gXRESET = 0
{
    VS1063_XRESET = 0;			
}

void VS1063_ResetOff(void)  //VS1063̃Zbg|[gXRESET = 1
{
    VS1063_XRESET = 1;			
}



void VS1063_RegSet(unsigned char Adrs, unsigned short int Data)
{
    unsigned char HighByte, LowByte;
    unsigned short int Ret;
    
	do{
        VS1063_XDCS = 1;		// f[^M[h@OFF
		while(!VS1063_DREQ);	// VS1063҂   // DREQ1ɂȂ܂ő҂
        VS1063_XCS = 0;			// R}hM[h@ON
        
		VS1063_WriteSPI(0x02);			// ݓw
		VS1063_WriteSPI(Adrs);		// WX^AhXo
		VS1063_WriteSPI(Data >> 8);		// ʃoCgo
		VS1063_WriteSPI((unsigned char)Data);		// ʃoCgo
        VS1063_XCS = 1;			// R}h[h OFF 
        while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
        VS1063_XCS = 0;			// R}h[h ON
		VS1063_WriteSPI(0x03);			// ǂݍݓ
		VS1063_WriteSPI(Adrs);		// WX^AhXw
        HighByte = VS1063_WriteSPI(0xFF);	//߂lFʃoCg
        LowByte = VS1063_WriteSPI(0xFF);	//߂lFʃoCg
        VS1063_XCS = 1;			// R}hM[h@OFF
        
        Ret = (HighByte << 8) + LowByte;
    
//        lcd_cmd(0x80);          //1sڂ̐擪
//        sprintf(Buf,"D=%d R=%d             ", Data,Ret);   //t@C@//󔒕K{
//        lcd_str(Buf);           // JnbZ[W1sڕ\
//        lcd_cmd(0xC0);          //Qsڂ̐擪
//        sprintf(Buf,"ysNum=%d             ", ysNum++);	//^b`YW\
//        lcd_str(Buf);           // JnbZ[W2sڕ\
//        delay_ms(1000);
    }while(Ret != Data);
    
}




//VS1063a GR[hpb`
void LoadUserCode_Compressed(void)    //GR[hpRLEk^pb`f[^ 
{
 unsigned short addr, n, val;
  //int i = 0;
  while (iy<sizeof(plugin)/sizeof(plugin[0])) {       //4522/2 = 2276
   
    addr = plugin[iy++];
    n = plugin[iy++];
    if (n & 0x8000U) { /* RLE run, replicate n samples */
      n &= 0x7FFF;
      val = plugin[iy++];
      while (n--) {
            mrxVS1063_WriteSci(addr, val);
//          sprintf(Buf,"iy=%d 0x%x,0x%x\r\n",iy, addr,val);    //WJf[^̃`FbNAfobNp
//          WriteString(Buf);
      }
    } else {           /* Copy run, copy n samples */
      while (n--) {
        val = plugin[iy++];
        mrxVS1063_WriteSci(addr, val);
//        sprintf(Buf,"iy=%d 0x%x,0x%x\r\n",iy, addr,val);      //WJf[^̃`FbNAfobNp
//        WriteString(Buf);
      }
    }
  }
}


void VS1063_Init(void)
{
    // VS1053p|[g̏ݒ 
    VS1063_XDCS = 1;			// DCS
	VS1063_XCS = 1;				// XCS
	VS1063_XRESET = 1;			// XRESET
    
    while(!VS1063_DREQ);	// VS1063҂   // DREQ1ɂȂ܂ő҂
 
    
	// NbNݒ //WX^ݒ̍ŏVS1063ãNbNAbvݒĂƁASPIM̃G[ጸ肷
     VS1063_RegSet(0x03, 0x6000);   //XTALI~3.0  --> 12.288MHz x3 = 36.864MHz   //IC[Jl
                                    //0x2000 	XTALI~2.0   //WMAt@CŃmCY
                                    //0x4000 	XTALI~2.5
                                    //0x6000 	XTALI~3.0
                                    //0x8000 	XTALI~3.5
                                    //0xa000 	XTALI~4.0
                                    //0xc000 	XTALI~4.5
                                    //0xe000 	XTALI~5.0
     
 
	// [hݒ
    VS1063_RegSet(0x00, 0x0800);    //f[^V[g
    
   
    // ʐݒ
    VS1063_RegSet(0x0B, 0x00);      //ʍő  //ftHgƓ
//    VS1063_RegSet(0x0B, 0x2F,0x2F);    //Ȃ    
//                                    //ʃoCgFA@ʃoCgFE
//                                    //ő0x00 - ŏ0xFF
//    
//    //BASSWX^(AhX0x02)̐ݒ
//    VS1063_RegSet(0x02, 0x7A, 0xF6);    //b12-b15: ʁC1.5dB(-8?+7C0=off)
//                                        //b8-b11: g,@1000Hz(1?15)
//                                        //0x7A: 10KHzオ10.5dB       //f[^V[g
//                                        //b7-b4: ቹʁC1dB(0?15C0=off)
//                                        //b3-b0: ቹg,10Hz(2?15)
                                            //0x00F6: 60Hzȉɂ15dB    //f[^V[g
    
    
    delay_ms(100);
    
//ȉAQl
// HarmonyMHCg킸ɃWX^𒼐ڐݒ肷ꍇ̗
// SPI1̏ݒ
//1.@䃌WX^    
//	SPI1CON = 0x8120;   //0b1000 0001 0010 0000 // 8rbg][h,CKP = 0,@CKE = 1
//@ȉASPI1CONrbgɐݒ肷ꍇ    
//    SPI1CON = 0;            //K{ SPI1CONbits.ENHBUF= 0@̈ 
//    SPI1CONbits.ON = 1;     //b15 //SPIW[ON   //SPI Peripheral is enabled
//                            //b14 `
//    SPI1CONbits.SIDL = 0;   //b13
//    SPI1CONbits.DISSDO = 0; //b12
//    SPI1CONbits.MODE32 = 0; //b11 //32rbg]@-->Wrbg]  //MODE32=0,MODE16=0,SPI1CONbits.AUDEN=0 R0Ȃ̂8rbg]
//    SPI1CONbits.MODE16 = 0; //b10 //16rbg]
//    SPI1CONbits.SMP = 0;    //b9  //o̓f[^ŃTvO//Input data sampled at middle of data output time
//    SPI1CONbits.CKE = 1;    //b8  //NbNAChANeBuωo 
//    SPI1CONbits.SSEN = 0;   //b7  //SSsOFF
//    SPI1CONbits.CKP = 0;    //b6  //NbNFANeBu1   //Idle state for clock is a low level; active state is a high level
//    SPI1CONbits.MSTEN = 1;  //b5  //}X^[[h
//    SPI1CONbits.DISSDI = 0; //b4
//    SPI1CONbits.STXISEL = 0;    //b3,b2   //SPIxTXIF is set when the last transfer is shifted out of SPISR and transmit operations are complete
//    SPI1CONbits.SRXISEL = 0;    //b1,b0   //SPIxRXIF is set when the last word in the receive buffer is read
//  
//2. SPI{[[g
//    SPI1BRG = 0x000F; ;   //SPI{[[g: 3.125MHz(= 100MHz/2 @(15 + 1) ) //4MHzNGA^[Qbg{[h삵Ȃ
//                                                                             //VS1053VS1011ɔrSPI{[[gȂ
//                          //SPI{[[g: X MHz( = Fpbclk(100MHz)/2 @(BRG<8:0> + 1) )
//    
}





//------------------------------------------------------------------------------
//PCM^iWAVE^j
void VS1063_PcmRec_Init(int patcheUse)   //jAPCM(WAVE)^@TvOg=44.1KHzA}jAQC = x 1AmA}CN
{
    // VS1053p|[g̏ݒ 
    VS1063_XDCS = 1;			// DCS
	VS1063_XCS = 1;				// XCS
	VS1063_XRESET = 1;			// XRESET
    
   while(!VS1063_DREQ);	// VS1063҂   // DREQ1ɂȂ܂ő҂  

   
//ŏVS1063ãNbNAbvsSPIʐM肷B   
//1. SCI_CLOCKFWX^F@NbNݒ
    VS1063_RegSet(SCI_CLOCKF , 0xe000);   //XTALI~5.0  --> 12.288MHz x5 = 61.44MHz   
                                    //0x2000 	XTALI~2.0   //WMAt@CŃmCY
                                    //0x4000 	XTALI~2.5
                                    //0x6000 	XTALI~3.0   //IC[Jl
                                    //0x8000 	XTALI~3.5
                                    //0xa000 	XTALI~4.0
                                    //0xc000 	XTALI~4.5
                                    //0xe000 	XTALI~5.0
    delay_ms(100);
    sprintf(Buf,"1. Clock SCI_CLOCKF=0xE000 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_CLOCKF));
    WriteString(Buf);

    
// GR[hpRLEk^pb`f[^ 

    if(patcheUse == 1)
    {
        LoadUserCode_Compressed();    //GR[hpRLEk^pb`f[^
        WriteString("Patched\r\n");
    }
    else WriteString("No Patche\r\n"); 
    
    delay_ms(100);

    
    
//2. SCI_AICTRL0WX^F<15:0> TvE[g̐ݒ<15:0> 8KHz - 48KHz
    mrxVS1063_WriteSci(SCI_AICTRL0, 44100U);  //44.1KHz@TvO[g
    sprintf(Buf,"2. SampleRate SCI_AICTRL0=44100U --> 0x%dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL0));
    WriteString(Buf);
    
//3. SCI_AICTRL1WX^F<15:0>@ @1ȏ̏ꍇF   ^QC = 1024/(<15:0>̐ݒl)@@ijݒl 512@--> ^QC1024/512@=@2@
//   @@@@@@@@@@@@@@@@@@0̏ꍇF@@@AGCiAutomatic Gain Control)

    mrxVS1063_WriteSci(SCI_AICTRL1, 1024U); // }jA@QC@x1@( = 1024 /1024)
    sprintf(Buf,"3. Gain x1 SCI_AICTRL1=1024U --> %dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL1));
    WriteString(Buf);
  
////4. SCI_AICTRL2WX^F<15:0> AGC QC̍őlݒ   
//    mrxVS1063_WriteSci(SCI_AICTRL2, 4096U); // AGC max gain 4.0x
//    sprintf(Buf,"4. SCI_AICTRL2=4096U --> %dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL2));
//    WriteString(Buf); 

    
//5. SCI_AICTRL3WX^F  <7:4> R[fbNA@ 
//                          <2:0> `l@0FXeIA2m
    
    mrxVS1063_WriteSci(SCI_AICTRL3, 0x12);      // mA jAPCM
    //mrxVS1063_WriteSci(SCI_AICTRL3, 0x32);    // mA WAVE A-lawi쌋ʁj -->@nO   //WAVE A-lawFT|[g
    //mrxVS1063_WriteSci(SCI_AICTRL3, 0x22);    // mA WAVE -lawi쌋ʁj-->@nO   //WAVE -lawFT|[g
    sprintf(Buf,"5. PCM stereo SCI_AICTRL3=0x12 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL3));
    WriteString(Buf);
     
         
//6. SCI_MODEWX^F [hݒF@}CN/C͑I(b14)AV[hAGR[hAZbgAADC[h 
    mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE);    //V[hAZbgAGR[hA}CN     //WX^̓ǂݏo͂Ȃ
    //mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE|SM_LINE1);    //V[hAZbgAGR[hAC

    
 delay_ms(100); 
}


//------------------------------------------------------------------------------
//IMA ADPCM ^
void VS1063_ImaRec_Init(int patcheUse)   //IMA ADPCMk@(WAVE)^@TvOg=44.1KHzA}jAQC = x 1AmA}CN
{
    // VS1053p|[g̏ݒ 
    VS1063_XDCS = 1;			// DCS
	VS1063_XCS = 1;				// XCS
	VS1063_XRESET = 1;			// XRESET
    
   while(!VS1063_DREQ);	// VS1063҂   // DREQ1ɂȂ܂ő҂  

   
//ŏVS1063ãNbNAbvsSPIʐM肷B   
//1. SCI_CLOCKFWX^F@NbNݒ
    VS1063_RegSet(SCI_CLOCKF , 0xe000);   //XTALI~5.0  --> 12.288MHz x5 = 61.44MHz   
                                    //0x2000 	XTALI~2.0   //WMAt@CŃmCY
                                    //0x4000 	XTALI~2.5
                                    //0x6000 	XTALI~3.0   //IC[Jl
                                    //0x8000 	XTALI~3.5
                                    //0xa000 	XTALI~4.0
                                    //0xc000 	XTALI~4.5
                                    //0xe000 	XTALI~5.0
    delay_ms(100);
    sprintf(Buf,"1. Clock SCI_CLOCKF=0xE000 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_CLOCKF));
    WriteString(Buf);
    
    
    
// GR[hpRLEk^pb`f[^ 

    if(patcheUse == 1)
    {
        LoadUserCode_Compressed();    //GR[hpRLEk^pb`f[^
        WriteString("Patched\r\n");
    }
    else WriteString("No Patche\r\n"); 
    
    delay_ms(100);

    
    
//2. SCI_AICTRL0WX^F<15:0> TvE[g̐ݒ<15:0> 8KHz - 48KHz
    mrxVS1063_WriteSci(SCI_AICTRL0, 44100U);  //44.1KHz@TvO[g
    sprintf(Buf,"2. SampleRate SCI_AICTRL0=44100U --> 0x%dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL0));
    WriteString(Buf);
    
//3. SCI_AICTRL1WX^F<15:0>@ 1ȏ̏ꍇF   ^QC = 1024/(<15:0>̐ݒl)@@ijݒl 512@--> ^QC1024/512@=@2@
//   @@@@@@@@@@@@@@@@@@0̏ꍇF@@@AGCiAutomatic Gain Control)

    mrxVS1063_WriteSci(SCI_AICTRL1, 1024U); // }jA@QC@x1@( = 1024 /1024)
    sprintf(Buf,"3. Gain x1 SCI_AICTRL1=1024U --> %dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL1));
    WriteString(Buf);

   
//5. SCI_AICTRL3WX^F  <7:4> R[fbNA@ 
//                          <2:0> `l@0FXeIA2m
    
    mrxVS1063_WriteSci(SCI_AICTRL3, 0x2); // mA IMA ADPCM
    sprintf(Buf,"5. IMA ADPCM stereo SCI_AICTRL3=0x02 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL3));
    WriteString(Buf);
     
         
//6. SCI_MODEWX^F [hݒF@}CN/C͑I(b14)AV[hAGR[hAZbgAADC[h 
    mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE);    //V[hAZbgAGR[hA}CN     //WX^̓ǂݏo͂Ȃ
    //mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE|SM_LINE1);    //V[hAZbgAGR[hAC

 delay_ms(100); 
}




//------------------------------------------------------------------------------
//Mp3 ^
void VS1063_Mp3Rec_Init(int patcheUse)   //MP3^@TvOg=44.1KHzArbg[g=128kbps }jAQC = x 1AmA}CN
{
    // VS1053p|[g̏ݒ 
    VS1063_XDCS = 1;			// DCS
	VS1063_XCS = 1;				// XCS
	VS1063_XRESET = 1;			// XRESET
    
   while(!VS1063_DREQ);	// VS1063҂   // DREQ1ɂȂ܂ő҂  

   
//ŏVS1063ãNbNAbvsSPIʐM肷B   
//1. SCI_CLOCKFWX^F@NbNݒ
    VS1063_RegSet(SCI_CLOCKF , 0xe000);   //XTALI~5.0  --> 12.288MHz x5 = 61.44MHz   
                                    //0x2000 	XTALI~2.0   //WMAt@CŃmCY
                                    //0x4000 	XTALI~2.5
                                    //0x6000 	XTALI~3.0   //IC[Jl
                                    //0x8000 	XTALI~3.5
                                    //0xa000 	XTALI~4.0
                                    //0xc000 	XTALI~4.5
                                    //0xe000 	XTALI~5.0
    delay_ms(100);
    sprintf(Buf,"1. Clock SCI_CLOCKF=0xE000 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_CLOCKF));
    WriteString(Buf);
    
    
    
// GR[hpRLEk^pb`f[^ 

    if(patcheUse == 1)
    {
        LoadUserCode_Compressed();    //GR[hpRLEk^pb`f[^
        WriteString("Patched\r\n");
    }
    else WriteString("No Patche\r\n"); 
    
    delay_ms(100);
    
    
//2. SCI_AICTRL0WX^F<15:0> TvE[g̐ݒ<15:0> 8KHz - 48KHz

    mrxVS1063_WriteSci(SCI_AICTRL0, 44100U);  //44.1KHz@TvO[g
//    mrxVS1063_WriteSci(SCI_AICTRL0, 22050U);  //22.05KHz@TvO[g    
//    mrxVS1063_WriteSci(SCI_AICTRL0, 48000U);  //48KHz@TvO[g

    sprintf(Buf,"2. SampleRate 44.1kHz SCI_AICTRL0=44100U --> 0x%dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL0));
    WriteString(Buf);
    
//3. SCI_AICTRL1WX^F<15:0>@ 1ȏ̏ꍇF   ^QC = 1024/(<15:0>̐ݒl)@@ijݒl 512@--> ^QC1024/512@=@2@
//   @@@@@@@@@@@@@@@@@@0̏ꍇF@@@AGCiAutomatic Gain Control)

    mrxVS1063_WriteSci(SCI_AICTRL1, 1024U); // }jA@QC@x1@( = 1024 /1024)
    sprintf(Buf,"3. Gain x1 SCI_AICTRL1=1024U --> %dU\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL1));
    WriteString(Buf);

   
//4. SCI_AICTRL3WX^F  <7:4> R[fbNA@ 
//                          <2:0> `l@0FXeIA2m
    
    mrxVS1063_WriteSci(SCI_AICTRL3, 0x62); // mA MP3
    sprintf(Buf,"4. MP3 stereo SCI_AICTRL3=0x62 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_AICTRL3));
    WriteString(Buf);
    
     
//5. rbg[g@CBR 128kbps/sec --> 0xE080

   VS1063_RegSet(SCI_WRAMADDR, 0xE080);     //CBR(Constant Bit Rate):(b15=1, b14=1) 0x80 = 128 kbit/s 
   //mrxVS1063_WriteSci(SCI_WRAMADDR, 0xE0A0); //CBR(Constant Bit Rate):(b15=1, b14=1) 0xA0 = 160 kbit/s
   sprintf(Buf,"5. BitRate 128Kbps SCI_WRAMADDR=0xE080 --> 0x%X\r\n\r\n",mrxVS1063_ReadSci(SCI_WRAMADDR));
   WriteString(Buf); 
     
         
//6. SCI_MODEWX^F [hݒF@}CN/C͑I(b14)AV[hAGR[hAZbgAADC[h 
    mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE);    //V[hAZbgAGR[hA}CN     //WX^̓ǂݏo͂Ȃ
    //mrxVS1063_WriteSci(SCI_MODE, SM_SDINEW|SM_RESET|SM_ENCODE|SM_LINE1);    //V[hAZbgAGR[hAC
    
 delay_ms(100); 
}



